Global ResX = 800
Global ResY = 600

Type Fld
 Field x,y,v,m
End Type

Type coin
 Field x,y,id,v
 Field tx,ty
 Field selected
End Type

Dim Map(12,12)
Dim Preset$(100)

Global CurrentPlayer=1, CoinSelected
Global GameMode=3, CurrentPreset, CountPreset, MouseButton1
Global CoinMaxValue = 8

Dir = ReadDir(".")

Repeat
 File$ = NextFile$(Dir)
 If Len(File$)> 3 Then ext$ = Mid$(File$, Len(File$)-2, 3)
 If ext$ = "bck" And FileType(File$) = 1 Then Preset$(CountPreset) = File$ : DebugLog Preset$(CountPreset): CountPreset = CountPreset + 1
Until File$ = ""


Datei = ReadFile("Settings.ini") 
 If Datei = 0 Then
  Screen = 2
  CurrentPreset = 3
 Else

  t1$ = ReadLine(Datei): i1 = Mid$(t1$, Len(t1$), 1)
  t2$ = ReadLine(Datei): i2 = Mid$(t2$, Len(t2$), 1) 
  t3$ = ReadLine(Datei): CurrentPreset = Mid$(t3$, Len(t3$), 1)
  If CurrentPreset > CountPreset Then CurrentPreset = CountPreset-1

  If i1 = 1 Then
   Text 0,0,"FullScreen (Y/N)"
   Repeat 
    If KeyHit(44) Then Screen = 1
    If KeyHit(49) Then Screen = 2
   Until Screen <> 0 Or KeyHit(1)
  Else
  
   If i2 = 1 Then 
    Screen = 1 
   Else 
    Screen = 2 
   EndIf

  EndIf
 EndIf

AppTitle "BattleCoins 1.0"
Graphics ResX, ResY, 32, Screen
SetBuffer BackBuffer()

Global CRG = LoadAnimImage("Gfx\cr.png",40,40,0,20)
Global CBG = LoadAnimImage("Gfx\cb.png",40,40,0,20)
Global FLG = LoadAnimImage("Gfx\fl.png",45,45,0,3)
Global MOG = LoadImage("Gfx\MO.png")
Global SBG = LoadImage("Gfx\SB2.png")
Global MNG = LoadAnimImage("Gfx\MN.png",124,31,0,7)
Global GOG = LoadAnimImage("Gfx\GO.png",274,95,0,3)
Global BLG = LoadImage("Gfx\BL.png")
MidHandle GOG


LoadPreset(Preset$(CurrentPreset))

Repeat
 Cls
 ClsColor 0,0,64
 
  UpdateScreen()
  UpdateInput()
  UpdateGame()
  UpdateInputKI()

  UpdateInputMenu()

  If Screen = 1 Then DrawImage MOG,MouseX(),MouseY()

  MouseButton1 = 0

 Flip
Until KeyHit(1)
End


Function UpdateGame()

 For c.coin = Each coin
  If c\id = 1 Then n1 = n1 + 1: v1 = v1 + c\v
  If c\id = 2 Then n2 = n2 + 1: v2 = v2 + c\v
 Next

 If n1 = 0 Or n2 = 0 Then CurrentPlayer = 1
 If n1 + n2 = 0 Then DrawImage GOG, (ResX/2)-100,ResY/2, 2: Return
 If n2 = 0 Then DrawImage GOG, (ResX/2)-100,ResY/2, 0: Return
 If n1 = 0 Then DrawImage GOG, (ResX/2)-100,ResY/2, 1: Return

 If CoinSelected Return

 For c.coin = Each coin

  If c\v > CoinMaxValue Then c\v = CoinMaxValue

  For f.fld = Each fld    
   If f\v <> 0 Then
    If f\x = c\x And f\y = c\y Then
     c\v = c\v + f\v
     f\v = 0
    EndIf
   EndIf
  Next

  For c2.coin = Each coin
   If c <> c2 Then
    If c\x = c2\x And c\y = c2\y Then
     If c\id = c2\id Then
      c\v = c\v + c2\v
      Delete c2
     Else
      If c\v > c2\v Then
       If GameMode = 3 Then c\v = c\v - (c2\v/2)
       If GameMode = 4 Then c\v = c\v + (c2\v/2)+1
       Delete c2 : Return
      EndIf
      If c\v < c2\v Then
       If GameMode = 3 Then c2\v = c2\v - (c\v/2)
       If GameMode = 4 Then c2\v = c2\v + (c\v/2)+1
       Delete c  : Return
      EndIf
      If c\v = c2\v Then Delete c: Delete c2:Return
     EndIf
    EndIf
   EndIf
  Next

  If c\v = 0 Then Delete c

 Next
End Function


Function KIMoveCoin(tmpcoin)
 c.coin = Object.coin(tmpcoin)
 If GameMode = 4 Then c\v = c\v - (Abstand(c\x, c\y, c\tx, c\ty)-1)
 c\x = c\tx: c\y = c\ty
 CurrentPlayer = 1
End Function


Function UpdateInputKI()
 If CurrentPlayer <> 2 Then Return

 For c.coin = Each coin
  If c\id = 1 And c\v > max1 Then max1 = c\v
  If c\id = 2 And c\v > max2 Then max2 = c\v
 Next

 .ki01
 vmax = 0
 tmpcoin = 0
 For c.coin = Each coin
  If c\id = 2 Then
   
   For f.fld = Each fld
    If f\v <> 0 And MoveValid(c\x,c\y,f\x,f\y,c\v) Then
     If f\v > vmax Then vmax = f\v: tmpcoin=Handle(c.coin): c\tx = f\x: c\ty = f\y
    EndIf
   Next

  EndIf
 Next
 
 If tmpcoin KIMoveCoin(tmpcoin): Return

 .ki02
 vmax = 0
 tmpcoin = 0
 For c.coin = Each coin
  For c2.coin = Each coin
   If c <> c2 And c\id = 2 Then
 
    If GameMode = 4 Then

     If c\id <> c2\id And (c\v - Abstand(c\x, c\y, c2\x, c2\y) + 1) > c2\v Then
      If MoveValid(c\x,c\y,c2\x,c2\y,c\v) Then
       If c2\v > vmax Then vmax = c2\v: tmpcoin=Handle(c.coin): c\tx = c2\x: c\ty = c2\y
      EndIf
     EndIf

    Else

     If c\id <> c2\id And c\v > c2\v Then
      If MoveValid(c\x,c\y,c2\x,c2\y,c\v) Then
       If c2\v > vmax Then vmax = c2\v: tmpcoin=Handle(c.coin): c\tx = c2\x: c\ty = c2\y
      EndIf
     EndIf

    EndIf

   EndIf
  Next
 Next

 If tmpcoin KIMoveCoin(tmpcoin): Return

 .ki03
 vmax = 0
 tmpcoin = 0
 For c.coin = Each coin
  For c2.coin = Each coin
   If c <> c2 And c\id = 2 And c2\id = 2 And c\v + c2\v <= CoinMaxValue Then 
    If MoveValid(c\x,c\y,c2\x,c2\y,c\v)
     If c2\v => vmax Then vmax = c2\v: tmpcoin=Handle(c.coin): c\tx = c2\x: c\ty = c2\y 
    EndIf   
   EndIf
  Next
 Next

 If tmpcoin KIMoveCoin(tmpcoin): Return

 .ki04
 For c.coin = Each coin
  For f.fld = Each fld
   If c\id = 2 Then
    If MoveValid(c\x,c\y,f\x,f\y,c\v) Then
     If GameMode = 4 Then c\v = c\v - (Abstand(c\x, c\y, c\tx, c\ty)-1)
     c\x = f\x
     c\y = f\y   
     CurrentPlayer = 1: Return
    EndIf
   EndIf
  Next
 Next

End Function


Function UpdateInput()

 If CurrentPlayer <> 1 Then Return

 MouseButton1 = MouseHit(1)
 MouseButton2 = MouseHit(2)

 If CoinSelected = 0 Then
  For c.coin = Each coin
   If c\id = 1 Then
    If MouseOver(3+(c\x*46),3+(c\y*46),43,43) And MouseButton1 Then c\selected = 1: CoinSelected = Handle(c) 
   EndIf
  Next
 Else
  For f.fld = Each fld
   If MouseOver( 2+(f\x*46), 2+(f\y*46), 45, 45) Then 
    c.coin = Object.coin(CoinSelected)
    If MoveValid(c\tx,c\ty,f\x,f\y,c\v)
     If GameMode = 4 Then 
      DrawImage CBG, 4+(c\x*46),4+(c\y*46), (c\v-1)-(Abstand(c\tx, c\ty, f\x, f\y)-1)
     EndIf
     c\x = f\x 
     c\y = f\y
    Else
     Color 96,0,0: Rect 3+(f\x*46),3+(f\y*46),43,43,1
     c\x = c\tx 
     c\y = c\ty
    EndIf

    If MouseButton2 Then c\x = c\tx : c\y = c\ty: c\selected = 0: CoinSelected = 0

    If MouseButton1 And MoveValid(c\tx,c\ty,f\x,f\y,c\v) Then
     If GameMode = 4 Then c\v = c\v - (Abstand(c\tx, c\ty, f\x, f\y)-1)
     c\selected = 0
     CoinSelected = 0
     c\tx= f\x
     c\ty= f\y
     CurrentPlayer = 2
    EndIf

   EndIf
  Next
 EndIf

End Function


Function UpdateInputMenu()
 mi = -1

 For i = 0 To 6
  If MouseOver(620, (i*32) + 180 , 124, 31) And MouseButton1 Then mi = i
 Next

 If mi = 0 Then LoadPreset(Preset$(CurrentPreset))

 If mi = 1 Then 
  CurrentPreset = CurrentPreset + 1
  If CurrentPreset > CountPreset-1 Then CurrentPreset = 0
  LoadPreset(Preset$(CurrentPreset))
 EndIf

 If mi > 2 And mi < 5 Then GameMode = mi 

 If mi = 6 Then End
End Function


Function UpdateScreen()

 For f.fld = Each fld
  If MouseOver (2+(f\x*46),2+(f\y*46),45,45) Then 
   DrawImage FLG, 2+(f\x*46), 2+(f\y*46), 2
  Else
   Color 255,255,128
   DrawImage FLG, 2+(f\x*46), 2+(f\y*46), f\m
   If f\v <> 0 Then Text 19+(f\x*46),18+(f\y*46), f\v
  EndIf
 Next

 For c.coin  = Each coin
  If c\selected = 1 Then Color 96,96,0: Rect 3+(c\tx*46),3+(c\ty*46),43,43,1
  If c\id = 1 Then Pic = CBG
  If c\id = 2 Then Pic = CRG
  If c\v > 0 And c\v < 21 Then DrawImage PIC,4+(c\x*46),4+(c\y*46),c\v-1
 Next


 If CoinSelected
  c.coin = Object.coin(CoinSelected)
  If c\v > 0 And c\v < 21 Then DrawImage CBG,4+(c\x*46),4+(c\y*46),c\v-1
 EndIf

 DrawImage SBG, 605, 5

 For c.coin = Each coin
  If c\id = 1 Then n1 = n1 + 1: v1 = v1 + c\v
  If c\id = 2 Then n2 = n2 + 1: v2 = v2 + c\v
 Next


 Color 255,255,0
 Text 666, 112, v1, 1
 Text 728, 112, v2, 1


 For i = 0 To 6
  DrawImage MNG, 620, (i*32) + 185 , i
 Next

 For i = 3 To 4
  If i = GameMode Then Color 64,128,0: DrawImage BLG, 626, (i*32) + 193
 Next

 Color 255,255,0
 Text 620, 570, "Preset: " + Preset$(CurrentPreset)

End Function


Function Abstand(x1,y1,x2,y2)
 If Abs(x1 - x2) > Abs(y1 - y2) Then Return Abs(x1 - x2)
 If Abs(x1 - x2) < Abs(y1 - y2) Then Return Abs(y1 - y2)
 Return Abs(x1-x2)
End Function


Function MoveValid(x1,y1,x2,y2,m)

If Not Abstand(x1,y1,x2,y2) <= m Then Return 0

For y = 0 To 12
 For x = 0 To 12
  Map(x,y) = -2
 Next
Next

Map(x1,y1) = 0 

For f.fld = Each fld
 If f\m = 1 Then Map(f\x,f\y) = -1
Next

 

n = -1
fr = MilliSecs()
Repeat

n=n+1

For y = 0 To 12
 For x = 0 To 12
  If Map(x,y) = n Then

   If x > 0 Then 
    If Map(x-1,y) = -2 Then Map(x-1,y) = n+1
   EndIf
  
   If x < 12 Then
    If Map(x+1,y) = -2 Then Map(x+1,y) = n+1
   EndIf

   If y > 0 Then 
    If Map(x,y-1) = -2 Then Map(x,y-1) = n+1
   EndIf
  
   If y < 12 Then
    If Map(x,y+1) = -2 Then Map(x,y+1) = n+1
   EndIf

   If x > 0 And y > 0 Then
    If Map(x-1,y-1)= -2 Then Map(x-1,y-1) = n+1
   EndIf

   If x < 12 And y > 0 Then
    If Map(x+1,y-1) = -2 Then Map(x+1,y-1) = n+1
   EndIf
  
   If x > 0 And y < 12 Then
    If Map(x-1,y+1) = -2 Then Map(x-1,y+1) = n+1
   EndIf

   If x < 12 And y < 12 Then
    If Map(x+1,y+1) = -2 Then Map(x+1,y+1) = n+1
   EndIf

  EndIf 
 Next
Next

Until Map(x2,y2) <> -2 Or MilliSecs()-fr > 5

If Map(x2,y2) = -2 Then Return 0
If Map(x2,y2) > 0 And Map(x2,y2) <= m Then Return 1

End Function


Function LoadPreset(File$)

 CurrentPlayer = Rnd(1,2)
 CoinSelected = 0

 Delete Each coin 
 Delete Each fld

 Datei = ReadFile(File$)

 fn = ReadByte(Datei)
 cn = ReadByte(Datei)

 For i = 1 To cn
  c.coin = New coin
  c\x = ReadByte(Datei)
  c\y = ReadByte(Datei)
  c\tx = c\x
  c\ty = c\y
  c\id = ReadByte(Datei)
  c\v = ReadByte(Datei)
 Next

 For i = 1 To fn
  f.fld = New fld
  f\x = ReadByte(Datei)
  f\y = ReadByte(Datei)
  f\v = ReadByte(Datei)
  f\m = ReadByte(Datei)
 Next

 CloseFile Datei

End Function


Function MouseOver(x,y,w,h)
 Color 0,0,64
 mx = MouseX()
 my = MouseY()
 If mx > x And mx < x+w And my > y And my < y+h Then Return 1
End Function