Graphics 640, 480,0,1
SetBuffer BackBuffer()
Global gras=LoadImage("images/Grass01.png")
Global kartoffel1=LoadImage("images/kartoffel1.png")
Global kartoffel2=LoadImage("images/kartoffel2.png")
Global kartoffel3=LoadImage("images/kartoffel3.png")
Global kreuz1=LoadImage("images/kreuz1.png")
Global kreuz2=LoadImage("images/kreuz2.png")
Global present1=LoadImage("images/present1.png")
Global present2=LoadImage("images/present2.png")
Global present3=LoadImage("images/present3.png")
Global back=LoadImage("images/back1.png")
Global Explosion=LoadAnimImage("images/EX2.bmp", 50,  50,  0,  25)
Global px=30,py=30,pscore
Global gx=20,gy=20,gscore
Global noscreen,zeit
Global t1$,t2$,t3$

Type kartoffel
Field x,y,bhandle
Field angle,speed,gesucht
End Type

Type TY 
Field x,x2,y2
End Type

Type boom
Field x,y,f
End Type

Global bo.boom
Global k.kartoffel
DrawImage back,0,0
SplitString "Herzlich Willkommen zum Game Kartoffelshooter. Sie mssen die fliegenden Kartoffeln Abschieen. Mit dem Steuerkreuz wird gelenkt und mit Enter geschossen, aber Achtung! Der Gegner schlft auch nicht, er schiet auch die Kartoffeln ab. Ein wenig wrze bringen die Items ins Spiel. Sie werden frh genug herausfinden was sie bewirken. Und nun viel Spa. Um das spiel zu starten drcken Sie eine beliebige Taste, um doch abzubrechen, drcken Sie ESCAPE.",100,100,480,0
Flip
WaitKey
If KeyHit(1) Then End
.again

SeedRnd MilliSecs()

For i=0 To Rand(3,5)
k=New kartoffel
k\x=Rand(1,640)
k\y=Rand(1,480)
blubb=Rand(1,3)
If blubb=1 Then k\bhandle=kartoffel1
If blubb=2 Then k\bhandle=kartoffel2
If blubb=3 Then k\bhandle=kartoffel3
k\angle=Rand(1,360)
k\speed=Rand(1,10)

Next
Repeat
Cls
TileBlock gras
update_kartoffel()
update_player()
update_gegner()
update_log()
update_explosion()

Text 10,10,"Spieler"
Text 10,30,pscore
Text 540,10,"Gegner"
Text 540,30,gscore


If pscore>200 Then 
.dNot
Cls 
DrawImage back,0,0
Flip
FlushKeys
Print "Herzlichen Glckwunsch, du hast gewonnen!"
Print "Drcken Sie 1 um zu beenden drcken Sie 2 um erneut zu spielen"
WaitKey
If KeyHit(2) Then End
If KeyHit(3) Then 
reset()
Goto again
EndIf
Goto dNot
EndIf

If gscore>200 Then 
FlushKeys
Cls
DrawImage back,0,0
Flip
Print "Leider Verloren..."
Print "Drcken Sie 1 um zu beenden drcken Sie 2 um erneut zu spielen"
WaitKey
If KeyHit(2) Then End
reset()
Goto again
EndIf


If noscreen<>1
Flip
Else
If MilliSecs-zeit>10000 Then noscreen=0
EndIf
Until KeyHit(1)


Cls
DrawImage back,0,0
Flip
FlushKeys
Print "Drcken Sie 1 um zu beenden drcken Sie 2 um weiter zu spielen."
WaitKey
If KeyHit(3) Then 
Goto again
ElseIf KeyHit(2) Then 
End
Else
Goto again
EndIf
Function newlog(nLog$)
t3=t2
t2=t1
t1=nLog$
End Function

Function update_log()
Text 50,350,"1. "+t1
Text 50,365,"2. "+t2
Text 50,380,"3. "+t3
End Function

Function reset()
Delete Each TY
Delete Each kartoffel
px=0
py=0
pscore=0
gscore=0
gx=0
gy=0
End Function



Function update_gegner()
If First TY=Null
For k=Each kartoffel
If k\x>0 And k\x<640 And k\y>0 And k\y<480
Abstand = Sqr((gx-k\x)^2 + (gy-k\y)^2)
If k\x>100 And k\x<540 And k\y>100 And k\y<380 Then abstand=abstand-50
t.TY= New TY
t\x = abstand
t\x2=k\x
t\y2=k\y
k\gesucht=1
Exit
EndIf
Next
Quicksort_Start()
EndIf
If First TY<>Null
t=First TY
If gx>0 And gx<640 And gy>0 And gy<480 And t\x2>0 And t\x2<640 And t\y2>0 And t\y2<480  
If t\x2<gx Then gx=gx-2
If t\x2>gx Then gx=gx+2
If t\y2<gy Then gy=gy-2
If t\y2>gy Then gy=gy+2
Else
If t\x2<gx Then gx=gx-2
If t\x2>gx Then gx=gx+2
If t\y2<gy Then gy=gy-2
If t\y2>gy Then gy=gy+2
Delete Each TY
For k=Each kartoffel
If k\gesucht=1 Then k\gesucht=0
Next
EndIf
EndIf
DrawImage kreuz2,gx,gy
End Function



Function update_player()
If KeyDown(200) And py>0 Then py=py-3
If KeyDown(208) And py+32<480 Then py=py+3
If KeyDown(203) And px>0 Then px=px-3
If KeyDown(205) And px+32<640 Then px=px+3
DrawImage kreuz1,px,py
End Function



Function update_kartoffel()
For k=Each kartoffel

k\x=k\x+Sin(k\angle)*k\speed
k\y=k\y+Cos(k\angle)*-k\speed
DrawImage k\bhandle,k\x,k\y
If ImagesCollide(kreuz1,px,py,0,k\bHandle,k\x,k\y,0) And KeyDown(57) Then 
create_explosion(k\x,k\y)
pscore=pscore+k\speed
If k\bhandle=present1 Or k\bhandle=present2 Or k\bhandle=present3 Then
bg=Rand(1,5)
bl=Rand(10,60)
If bg=1 Then
pscore=pscore+bl
newlog("Dir wurden "+bl+" score-punkte hinzugefgt.")
ElseIf bg=2
pscore=pscore-bl
newlog("Dir wurden "+bl+" score-punkte abgezogen.")
ElseIf bg=3
gscore=gscore+bl
newlog("Dem Gegner wurden "+bl+" score-punkte hinzugefgt.")
ElseIf bg=4
gscore=gscore-bl
newlog("Dem Gegner wurden "+bl+" score-punkte abgezogen.")
ElseIf bg=5
noscreen=1
zeit=MilliSecs()
EndIf
EndIf
If k\gesucht=1 Then Delete Each TY
Delete k.kartoffel
Goto back
EndIf
If ImagesCollide(kreuz2,gx,gy,0,k\bHandle,k\x,k\y,0) Then 
create_explosion(k\x,k\y)
If k\bhandle=present1 Or k\bhandle=present2 Or k\bhandle=present3 Then
bg=Rand(1,5)
bl=Rand(10,60)
If bg=1 Then
pscore=pscore+bl
newlog("Dir wurden "+bl+" score-punkte hinzugefgt.")
ElseIf bg=2
pscore=pscore-bl
newlog("Dir wurden "+bl+" score-punkte abgezogen.")
ElseIf bg=3
gscore=gscore+bl
newlog("Dem Gegner wurden "+bl+" score-punkte hinzugefgt.")
ElseIf bg=4
gscore=gscore-bl
newlog("Dem Gegner wurden "+bl+" score-punkte abgezogen.")
ElseIf bg=5
noscreen=1
zeit=MilliSecs()
EndIf
EndIf
gscore=gscore+k\speed
Delete k.kartoffel
Delete Each TY
Goto back
EndIf
If k\gesucht=1 And k\x>0 And k\x<640 And k\y>0 And k\y<480 And k\x>100 And k\x<540 And k\y>100 And k\y<380 And Rand(1,10)<>1
k\gesucht=1
Else
k\gesucht=0
Delete Each TY
EndIf


If k\x<-100 Or k\x>740 Or k\y<-100 Or k\y>680
If k\gesucht=1 Then Delete Each TY:k\gesucht=0
If Rand(1,2)=1 Then
k\x=Rand(-50,640)
k\y=-32
Else
k\y=Rand(-50,480)
k\x=-32
EndIf
blubb=Rand(1,3)
If blubb=1 Then k\bhandle=kartoffel1
If blubb=2 Then k\bhandle=kartoffel2
If blubb=3 Then k\bhandle=kartoffel3
k\angle=Rand(0,360)
k\speed=Rand(1,5)
EndIf 
.back
Next
If (Rand(1,70))=50 Then create_kartoffel()
End Function



Function create_kartoffel()
k=New kartoffel
If Rand(1,2)=1 Then
k\x=Rand(-50,640)
k\y=-32
Else
k\y=Rand(-50,480)
k\x=-32
EndIf
blubb=Rand(1,6)
If blubb=1 Then k\bhandle=kartoffel1
If blubb=2 Then k\bhandle=kartoffel2
If blubb=3 Then k\bhandle=kartoffel3
If blubb=4 Then k\bhandle=present1
If blubb=5 Then k\bhandle=present2
If blubb=6 Then k\bhandle=present3
k\angle=Rand(0,360)
k\speed=Rand(1,5)
End Function


Function Quicksort_Start()
   a.TY= First TY
   b.TY = Last TY
   If a.TY = Null  Return
   If a <> b Then Quicksort(a.TY,b.TY)
    End Function
    Function Quicksort(a.TY,b.TY)
            s2.Ty = A.TY
            s3.TY = A.TY
            Repeat
                s1.TY=After s2.TY
                If s1\x< a\x Then
                    If s1 = b.TY Then
                        b.Ty=Before s1
                        GoOut = 1
                    Else
                    s2= Before s1
                    End If
                    Insert S1.TY Before a.TY
                    If s3.TY = A.Ty Then s3.ty=s1.TY
                Else
                    If s1.TY= b.Ty Then Exit
                    s2.TY = s1
                End If
            Until goout
        If s3.Ty <> a.TY
            s1 = Before a.TY
            If s1<> s3 Then Quicksort(s3.TY,s1.TY)
        End If
        If a.Ty <> b.TY
            s1 = After a.TY
            If s1 <> b Then Quicksort(s1.TY,b.TY)
        End If
End Function 
Function SplitString(msg$,x,y,w%,style) ;Style:0normal,1 zentriert; w gibt die breite an 
   If StringWidth(msg$) < w Then
      If style=0 Then Text x,y,msg
     If style=1 Then Text (x+(w/2))-(StringWidth(msg)/2),y,msg$
    
   Else
      For char = 1 To Len(msg$)
       i=i+1
         If StringWidth(Left(msg$, char)) > w
            Repeat
               char = char - 1               
            Until IsAbleToWrap(Mid(msg$,char,1))

            If style=0 Then Text x,y,Left(msg$,char)
         If style=1 Then Text (x+(w/2))-StringWidth(Left(msg$,char))/2,y,Left(msg$,char)


            SplitString(Trim(Right(msg$,Len(msg$)-char)),x,y+FontHeight()+3, w,style)

            Exit
         End If
      Next
   End If
End Function 

Function IsAbleToWrap(char$)
    Select char
      Case ".", ",", ";", ":", "!", "?", "-", " "
         AbleToWrap = True
      Default
         AbleToWrap = False
   End Select
   Return AbleToWrap
End Function 

Function create_explosion(x,y)
bo=New boom
bo\x=x
bo\y=y
End Function

Function update_explosion()
For bo=Each boom
DrawImage Explosion,bo\x,bo\y,bo\f
bo\f=bo\f+1
If bo\f=25 Then Delete bo.boom
Next
End Function