SuperStrict
Import pub.opengl
SeedRnd MilliSecs()
GLGraphics(320,240,0,60,GRAPHICS_BACKBUFFER)
glViewport(0,0,320,240)
glOrtho(0.0,320,240,0.0,-1.0,1.0)
glEnable(GL_TEXTURE_2D)			
glEnable(GL_BLEND)	
glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA)
glClearColor(0,0,0.2,0)
Global tiles:Int[6]
tiles[0]=GLTexFromPixmap(LoadPixmap("tile1.png"))
tiles[1]=GLTexFromPixmap(LoadPixmap("tile2.png"))
tiles[2]=GLTexFromPixmap(LoadPixmap("tile3.png"))
tiles[3]=GLTexFromPixmap(LoadPixmap("tile4.png"))
tiles[4]=GLTexFromPixmap(LoadPixmap("tile5.png"))
tiles[5]=GLTexFromPixmap(LoadPixmap("tile6.png"))
Global sprites:Int[4]
sprites[0]=GLTexFromPixmap(LoadPixmap("sprite0.png"))
sprites[1]=GLTexFromPixmap(LoadPixmap("sprite1.png"))
sprites[2]=GLTexFromPixmap(LoadPixmap("sprite2.png"))
sprites[3]=GLTexFromPixmap(LoadPixmap("sprite3.png"))
Global prices:Int[]=[1000,5000,500]
Type Player
	Field attacking:Int=0
	Field money:Int=4000
	Field buildings:TList=CreateList()
	Field w:World
	Field nr:Byte
	Field count:Int
	Field mx:Int
	Field ki:Tlist=CreateList()
	Field kicount:Int=0
	Method fire:Int(b:Building,ta:Int,tb:Int)
		If(b.timer=5000)
			Local r:Rocket=New Rocket
			r.init(w)
			r.tx=(ta+.5)*5.625
			r.ty=(tb+.5)*5.625
			r.a=5.625*(b.x+.5)
			r.b=5.625*(b.y+.5)
			b.timer=0
			attacking=240
			Return 1
		EndIf 
		Return 0
	End Method
	
	Method search:Position(x:Int,y:Int)
		If(money<prices[2]) Return Null 
		money=money-prices[2]
		For Local a:Int=x+61 To x+67
			For Local b:Int=y+61 To y+67
				Local i:Int=a Mod 64
				Local j:Int=b	 Mod 64
				If(w.mapdata[(i+j-(j Mod 32)) Mod 64,Abs((j>32)*32-(j Mod 32)),1]<>0 And w.mapdata[(i+j-(j Mod 32)) Mod 64,Abs((j>32)*32-(j Mod 32)),0]=2+nr) Then 
					Local re:Position=New Position
					re.x=i
					re.y=j
					Return re
				EndIf 
			Next
		Next
		Return Null
	End Method
	Method build:Int(x:Int,y:Int,typ:Int)
		If(w.mapdata[x,y,0]=2+nr) Then 
			
			If(typ>=0)
				If(money<prices[typ]) Return 0
				money=money-prices[typ]
				Local a:Building=New Building
				a.typ=typ
				a.x=x
				a.y=y
				ListAddLast(buildings,a)
			EndIf 
			w.mapdata[x,y,0]=4+typ
			For Local a:Int=x+61 To x+67
				For Local b:Int=y+61 To y+67
					Local i:Int=a Mod 64
					Local j:Int=b	 Mod 64
					If(w.mapdata[(i+j-(j Mod 32)) Mod 64,Abs((j>32)*32-(j Mod 32)),0]=0) Then 
						w.mapdata[(i+j-(j Mod 32)) Mod 64,Abs((j>32)*32-(j Mod 32)),0]=2+nr
						w.mapdata[(i+j-(j Mod 32)) Mod 64,Abs((j>32)*32-(j Mod 32)),2]=100;count=count+100
						If(count>mx) Then mx=count
					EndIf 
				Next
			Next
		EndIf
		Return 1
	End Method 
	
	Method update()
		attacking=attacking-1
		If(attacking<0) attacking=0
		For Local a:Building=EachIn buildings
			If(w.mapdata[a.x,a.y,0]<>a.typ+4) Then ListRemove(buildings,a);Continue			
			a.timer=a.timer+2
			If(a.typ=0) Then
				If(a.timer>300)
					a.timer=0
					If(w.mapdata[a.x,a.y,1]>0) Then
						money=money+100
						'w.mapdata[a.x,a.y,1]=w.mapdata[a.x,a.y,1]-100
						
					EndIf
				EndIf
			ElseIf a.typ=1 Then
				If(a.timer>5000) a.timer=5000
			EndIf
		Next
		count=0
		For Local x:Int=0 To 63
			For Local y:Int=0 To 31
				If(w.mapdata[x,y,0]=2+nr) Then count=count+w.mapdata[x,y,2]
			Next
		Next 
		If(1.0*count/mx<0.4) Then count=0
	End Method
	
	Method act:Int()
		'auf neue situationen reagieren
		If((1.0*count/mx)<0.5 And ki.firstlink().value()<>"3") Then DebugLog "panik";ListAddFirst(ki,"3")
			'angriff		
		If((p1.attacking>0 Or countRocket()>3) And ki.Firstlink().value()<>"4")	
			'genug raketen
			For Local i:Int=0 To countrocket()-1
				ListAddFirst(ki,"4")
			Next
		EndIf 
		'alte situationen abarbeiten
		If(CountList(ki)>0)
			If(ki.first()="1")				
			'l
				
				If(money>=1500)
				'genug geld
					Local p:Position=getPos()
					If(kicount=3) ListAddFirst(ki,"3") 'land erweitern
					DebugLog "l bauen"+p.x+"-"+p.y
					p=search(p.x,p.y)
					'suchen
					kicount=kicount+1
					If(p<>Null) Then 
						kicount=0
						build(p.x,p.y,0)	
						'bauen
						ki.firstlink().remove()
					EndIf 
				EndIf
			ElseIf(ki.first()="2")
			'raketen
				kicount=kicount+1
				If(kicount=200) ListAddFirst(ki,"1")
				If(money>=5000)
				'genug geld
					
					Local p:Position=getPos()										
					If(p<>Null) Then 
						DebugLog "atom"
						'bauen
						kicount=0
						build(p.x,p.y,1)	
						'bauen
						ki.firstlink().remove()
					EndIf 
				EndIf 
			
			ElseIf(ki.first()="3")
				If(money>=1000)
					ki.firstlink().remove()
					If(money>=1000)
					'genug geld
					
						Local p:Position=getPos()										
						If(p<>Null) Then 
							DebugLog "erweitern"
							'bauen
							kicount=0
							build(p.x,p.y,0)	
							'bauen
							ki.firstlink().remove()
						EndIf 
					EndIf
					
				EndIf
			ElseIf(ki.first()="4")
				'abschuss
				'fertige rakete suchen
					'ziel suchen
						'abschuss
				If(countRocket()=0) Then ki.firstlink().remove();
				For Local b:Building=EachIn buildings
					If(b.typ=1) 
						If(CountList(p1.buildings)>0)
							Local target:Building=Building(p1.buildings.valueatindex(Rand(-1,CountList(p1.buildings)-1)))
							If(fire(b,target.x,target.y)) Then ki.firstlink().remove();Exit
						Else
							Local target:Position=findLand()
							If(fire(b,target.x,target.y)) Then ki.firstlink().remove();Exit
						EndIf	
					EndIf
				Next
			EndIf 
		EndIf 
		If(CountList(ki)=0) Then 
		'nichts zu tun
			If(CountList(buildings)>3 And Rand(1,2)=1)
				ListAddLast(ki,"2")
			Else
				ListAddLast(ki,"1")
			EndIf
			'was dazu packen, gebitsausbau, neue angriffsmglicheiten
		EndIf 
		Return 1
	End Method
	Method countRocket:Int()
		Local re:Int
		For Local a:Building=EachIn buildings
			If(a.typ=1) re=re+1
		Next
		Return re
	End Method 
	
	Method getPos:Position()
		Local re:Position=New Position
		If(CountList(buildings)=0) re.x=42;re.y=10;Return re
		Local bu:Building;
		Repeat
			bu=Building(buildings.valueatindex(Rand(0,CountList(ki)-1)))
			re.x=(bu.x+64)
			re.y=(bu.y+32)
			Local dx:Int=Rand(-2,1)
			Local dy:Int=Rand(-2,1)
			Repeat
				re.x=re.x+dx
				re.y=re.y+dy
				If(w.mapdata[re.x Mod 64,re.y Mod 32,0]<>2+nr)					
					If(w.mapdata[(re.x-dx)Mod 64,(re.y-dy)Mod 32,0]=2+nr)
						
						re.x=(re.x-dx) Mod 64
						re.y=(re.y-dy) Mod 32
						DebugLog re.x+"/"+re.y 
						Return re
					Else
						Exit
					EndIf
				EndIf 
			Forever
		Forever
		Return Null 
	End Method	
	Method findLand:Position()
		For  Local x:Int=0 To 63
			For Local y:Int=0 To 31
				If(w.mapdata[x,y,0]=2) 
					Local re:Position=New Position
					re.x=x
					re.y=y
					Return re
				EndIf
			Next
		Next
	EndMethod 
	Method New()
		ListAddLast(ki,"1")
	End Method 
End Type

Type Building
	Field typ:Int
	Field timer:Int
	Field x:Int,y:Int	
End Type

Type Position
	Field x:Byte,y:Byte
End Type

Type World
	Field mapdata:Int[64,32,3]'0-tile;1-l;2-bevlkerung
	Field a:Int, b:Int
	Field zoom:Int 
	Field px:Int=160
	Field py:Int=120
	Field sx:Int=-1
	Field sy:Int=-1
	Field ax:Float=-1
	Field ay:Float=-1
	Field sprites:TList=CreateList()
	Method draw:Int()
		sx=-1;sy=-1
		Local ab:Double=5.625
		For Local i:Int=0 To 63
			For Local j:Int=0 To 63
				Local vertices:Float[8]
				Local draw:Int=True
				For Local y:Int=0 To 1 Step 1
					For Local x:Int=0 To 1 Step 1
						If((ab*(i+x)+a) Mod 360 <=180 And (ab*(j+y)+b) Mod 360 <=180)  Then 
							vertices[(x*2+y)*2]=px-Sin(ab*(j+y)+b)*Cos(a+(i+x)*ab)*zoom
							vertices[(x*2+y)*2+1]=py-Cos(ab*(j+y)+b)*zoom						
						Else 
							draw=False
						EndIf
					Next
				Next
				If(draw) Then
					
					vertices=sortvertices(vertices)
					glBindTexture(GL_TEXTURE_2D, tiles[mapdata[(i+j-(j Mod 32)) Mod 64,Abs((j>32)*32-(j Mod 32)),0]]) '
					
					glBegin(GL_QUADS)
						glTexCoord2f(0,0)
						glVertex3f(vertices[0],vertices[1],0)
						glTexCoord2f(1,0)	
						glVertex3f(vertices[2],vertices[3],0)	
						glTexCoord2f(1,1)	
						glVertex3f(vertices[4],vertices[5],0)
						glTexCoord2f(0,1)	
						glVertex3f(vertices[6],vertices[7],0)	
						If(isinTriangle(MouseX(),MouseY(),vertices[0],vertices[1],vertices[2],vertices[3],vertices[6],vertices[7]) Or isinTriangle(MouseX(),MouseY(),vertices[2],vertices[3],vertices[6],vertices[7],vertices[4],vertices[5]))
							sx=(i+j-(j Mod 32)) Mod 64
							sy=Abs((j>32)*32-(j Mod 32))	
							ax=(ab*(i+0.5))Mod 360
							ay=(ab*(j+0.5))Mod 360
						EndIf 
					glend()
				EndIf
			Next
		Next	
		For Local s:Sprite=EachIn Sprites
			s.draw()
		Next	
	End Method

	Method addA:Int(s:Int)
		a=(a+s)Mod 360
	End Method
	Method addB:Int(s:Int)
		b=(b+s) Mod 360
	End Method 

	Method addZoom(s:Int)
		zoom=zoom+s
		If(zoom<120) zoom=120
		If(zoom>1000) zoom=1000
	End Method 

	Method loadData(file:String)
		Local fil:TStream=OpenFile(file)		
		For Local y:Int=0 To 31
			For Local x:Int=0 To 63
				mapdata[x,y,0]=ReadByte(fil)
				Local rn:Int=Rand(10)
				
				If(rn=1) mapdata[x,y,1]=10000
			Next
		Next
		mapdata[8,10,0]=2
		mapdata[42,10,0]=3 
	End Method

	Method sortVertices:Float[](ver:Float[])
		For Local x:Int=1 To 5 Step 2
			For Local y:Int=x+2 To 7 Step 2
				If(ver[y]<ver[x])
					Local tmp:Float=ver[x]
					ver[x]=ver[y]
					ver[y]=tmp
					tmp=ver[x-1]
					ver[x-1]=ver[y-1]
					ver[y-1]=tmp
				EndIf
			Next
		Next		
		If(ver[0]>ver[2])
			Local tmp:Float=ver[0]
			ver[0]=ver[2]
			ver[2]=tmp
			tmp=ver[1]
			ver[1]=ver[3]
			ver[3]=tmp
		EndIf 
		If(ver[6]>ver[4])
			Local tmp:Float=ver[6]
			ver[6]=ver[4]
			ver[4]=tmp
			tmp=ver[7]
			ver[7]=ver[5]
			ver[5]=tmp
		EndIf 	
		Return ver
	End Method 

	Method isInTriangle:Int( px#,py#, ax#,ay#,bx#,by#,cx#,cy# ) 
		Local bc:Float,ca:Float,ab:Float,ap:Float,bp:Float,cp:Float,abc:Float
		bc = bx*cy - by*cx 
		ca = cx*ay - cy*ax 
		ab = ax*by - ay*bx
		ap = ax*py - ay*px
		bp = bx*py - by*px
		cp = cx*py - cy*px
		abc = Sgn(bc + ca + ab)
		If (abc*(bc-bp+cp)>0) And (abc*(ca-cp+ap)>0) And (abc*(ab-ap+bp)>0) Then Return True
		Return False
	End Method
End Type

Type Sprite
	Field a:Float
	Field b:Float
	Field tex:Int
	Field rot:Float=90.0
	Field w:World

	Method draw()
		Local vertices:Float[8]
		vertices[0]=0.0+a+Cos(rot-45)*2.5+w.a
		vertices[1]=0.0+b-Sin(rot-45)*2.5+w.b
		vertices[2]=0.0+a+Cos(rot-45+90)*2.5+w.a
		vertices[3]=0.0+b-Sin(rot-45+90)*2.5+w.b
		vertices[4]=0.0+A+Cos(rot-45+180)*2.5+w.a
		vertices[5]=0.0+b-Sin(rot-45+180)*2.5+w.b
		vertices[6]=0.0+A+Cos(rot-45+270)*2.5+w.a
		vertices[7]=0.0+b-Sin(rot-45+270)*2.5+w.b
		Local draw:Int=True;
		For Local i:Int=0 To 7 Step 2
			If(vertices[i] Mod 360<=180 And vertices[i+1] Mod 360<=180)
					vertices[i]=w.px-Sin(vertices[i+1])*Cos(vertices[i])*w.zoom
					vertices[i+1]=w.py-Cos(vertices[i+1])*w.zoom	
			Else
					draw=False
			EndIf			
		Next
		If(draw) Then 
			glBindTexture(GL_TEXTURE_2D, sprites[tex])
			glBegin(GL_QUADS)
				glTexCoord2f(0,0)
				glVertex3f(vertices[0],vertices[1],0)
				glTexCoord2f(1,0)	
				glVertex3f(vertices[2],vertices[3],0)	
				glTexCoord2f(1,1)	
				glVertex3f(vertices[4],vertices[5],0)
				glTexCoord2f(0,1)	
				glVertex3f(vertices[6],vertices[7],0)	
			glend()
		EndIf
	End Method
	Method init:Sprite(pw:World)
		w=pw
		ListAddLast(w.sprites,Self)
		Return Self
	End Method 
	
End Type

Type Rocket Extends Sprite
	Field tx:Float,ty:Float
	Method draw()
		rot=ATan2(ty-b,a-tx)+180
		a=a+Cos(rot)/4
		b=b-Sin(rot)/4
		If(Abs(b-ty)<1 And Abs(a-tx)<1) Then
			'BIGBM
			Local x:Int=Int(a/5.625)
			Local y:Int=Int(b/5.625)
			For Local a:Int=x+63-Rand(1) To x+65+Rand(1)
				For Local b:Int=y+63-Rand(1) To y+65+Rand(1)
					Local i:Int=a Mod 64
					Local j:Int=b	 Mod 64
					If(w.mapdata[(i+j-(j Mod 32)) Mod 64,Abs((j>32)*32-(j Mod 32)),0]>1) Then 
						w.mapdata[(i+j-(j Mod 32)) Mod 64,Abs((j>32)*32-(j Mod 32)),0]=0
						w.mapdata[(i+j-(j Mod 32)) Mod 64,Abs((j>32)*32-(j Mod 32)),2]=0
					EndIf 
				Next
			Next
			ListRemove(w.sprites,Self)
		EndIf
		super.draw()
	End Method 
	Method init:Rocket(pw:World)
		w=pw
		tex=1
		ListAddLast(w.sprites,Self)
		Return Self
	End Method 
End Type 	

Local mesg:String=""

Local w:World=New World
w.addA(30)
w.LoadData("world.map")
Local x:Int=8
Local y:Int=10
Local sel:Byte=1
Local p:Sprite=New Sprite.init(w)
p.w=w
p.tex=3
p.a=5.625*(x+.5)
p.b=5.625*(y+.5)

Local mz:Int=MouseZ()
Global p1:Player=New Player
Local p2:Player=New Player
p2.nr=1
p2.w=w
p2.build(42,10,-1)

p1.w=w
p1.build(8,10,-2)

Local i:Int=0
Repeat	
	i=i+1
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();	
	glClearColor(Sin(p2.attacking*5),0,0.2,0)
	'If(p2.attacking>0) glClearColor(Sin(p2.attacking,0,0,0)
	glViewport(0,0,320,240);
	glOrtho(0.0,320,240,0.0,-1.0,1.0)
	w.draw()	
	If(KeyDown(KEY_UP)) Then w.addB(358)
	If(KeyDown(KEY_DOWN)) Then w.addB(2)
	If(KeyDown(KEY_LEFT)) Then w.addA(358)
	If(KeyDown(KEY_RIGHT)) Then w.addA(2)
	If(KeyHit(KEY_1)) Then p1.build(x,y,0)
	If(KeyHit(KEY_2)) Then p1.build(x,y,1)
	If(KeyHit(KEY_3)) Then 
		Local re:Position=p1.search(x,y)
		mesg="No Oil found"
		If(re<>Null) Then mesg="Oil has been fond at ("+re.x+"/"+re.y+")"
	EndIf 
	If(MouseHit(1)And w.sx<>-1) Then 
		x=w.sx
		y=w.sy
		p.a=w.ax
		p.b=w.ay
	EndIf
	If(MouseHit(2))
		Local starter:Building	
		For starter=EachIn p1.buildings
			If(starter.x=x And starter.y=y) Then 
				mesg=Int(((starter.timer/5000.0)*100.0))+"% fertig geladen"
				p1.fire(starter,w.sx,w.sy)
				If(starter.timer=0)
					mesg="Rakete abgeschossen"
				EndIf 
				Exit
			EndIf 
		Next
	EndIf 
	w.addZoom((MouseZ()-mz)*10)
	mz=MouseZ() 
	p1.update()
	p2.update()
	If(p1.count=0 Or p2.count=0) Then Exit
	If(i=120)Then p2.act();i=0
	GLDrawText "Population: "+p1.count+"/"+p1.mx,0,0
	GLDrawText "Capital: "+p1.money+"$",0,12
	GLDrawText w.sx+"/"+w.sy,270,0	
	GLDrawText mesg,0,222
	Flip
Until KeyHit(KEY_ESCAPE Or AppTerminate()=True)
If(p2.count=0) Then 
	DebugLog "gewonnen"
Else
	DebugLog "verloren"
EndIf 